#ifndef GLWIDGET_H
#define GLWIDGET_H

#include <QGLWidget>
#include <QMouseEvent>

#include <QColor>
#include <QList>

#include "kostka.h"

class GLWidget : public QGLWidget
{
    Q_OBJECT

public:
    explicit GLWidget(QWidget* parent = 0, QList<Kostka*>& kostky = QList<Kostka*>());
    ~GLWidget();

        void rotateBy(int xAngle, int yAngle, int zAngle);

protected:
    void initializeGL();
    void resizeGL(int width, int height);
    void paintGL();
    void update(float t);

    void mousePressEvent(QMouseEvent* e);
    void mouseReleaseEvent(QMouseEvent* e);
    void mouseMoveEvent(QMouseEvent* e);

    void timerEvent(QTimerEvent*);

private:
    QList<Kostka*> kosticky;

    QOpenGLContext *m_context;

    float m_panAngle;
        float m_tiltAngle;
        float panAngle;
        float tiltAngle;
        float camera_zoom;
        float aspectRatio;
        float nearPlane;
        float farPlane;

        QPoint mouse_position;

        QPoint prevMousePos;
        QPoint mousePos;

        bool leftButtonPressed, rightButtonPressed, wasLeftButtonPressed;
        bool viewCenterFixed;

        float time;


        QPoint lastPos;
        int xRot;
        int yRot;
        int zRot;

        int floorSel;
        int floorSel2;

signals:

public slots:
        void selectFloor(int fl);
        void selectFloor2(int fl);
};

#endif // GLWIDGET_H
