#include "mainwindow.h"
#include "ui_mainwindow.h"

#include "kostka.h"

#include <QFileDialog>
#include <QFile>
#include <QTextStream>
#include <QList>
#include <QHash>

#include <QMessageBox>
#include <QDebug>

MainWindow::MainWindow(QWidget* parent) : QMainWindow(parent), ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    QString path = QFileDialog::getOpenFileName(this, "Zvolte soubor z kterého chce vygenerovat budovu");

    QFile file(path);

    file.open(QIODevice::ReadOnly);

    QTextStream ts(&file);
    ts.setCodec("UTF-8");

    int i = 0;

    int X = 0;
    int Y = 0;

    QString type = QString();

    while(!ts.atEnd())
    {
        QString line = ts.readLine();

        if(i == 0)
        {
            QStringList split = line.split(' ', QString::SkipEmptyParts);

            X = split[0].toInt();
            Y = split[1].toInt();
            type = split[2];
        }
        else
        {
            QStringList split = line.split(' ', QString::SkipEmptyParts);

            if(split.length() == 0)
                continue;

            // 5 parts
            int floor = split[0].toInt();
            int x     = split[1].toInt();
            int y     = split[2].toInt();

            QChar color = split[3][0];

            QString size = split[4];

            kostky.append(new Kostka(floor, x, y, color, size));
        }

        i++;
    }

    glWidget = new GLWidget(NULL, kostky);

    setCentralWidget(glWidget);

    slider = new QSlider();
    slider->setMinimum(0);
    slider->setMaximum(kostky.last()->Floor);

    ui->mainToolBar->addWidget(slider);

    connect(slider, SIGNAL(valueChanged(int)), glWidget, SLOT(selectFloor(int)));

    slider2 = new QSlider();
    slider2->setMinimum(0);
    slider2->setMaximum(kostky.last()->Floor);

    ui->mainToolBar->addWidget(slider2);

    connect(slider2, SIGNAL(valueChanged(int)), glWidget, SLOT(selectFloor2(int)));

    connect(ui->actionRekapitulace, SIGNAL(triggered()), this, SLOT(showRekapitulace()));
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::showRekapitulace()
{
    QString rekap = QString();

    QHash<QString, int> blabla;

    foreach(Kostka* kostka, kostky)
    {
        QString bla = QString("%1 %2").arg(kostka->Color).arg(kostka->Size);

        if(blabla.contains(bla))
            blabla[bla]++;
        else
            blabla[bla] = 1;
    }

    QList<QString> keys = blabla.keys();

    for(int i = 0; i < blabla.count(); ++i)
    {

        rekap += QString("%1 %2\n").arg(keys[i]).arg(blabla[keys[i]]);
    }

    QMessageBox::information(this, "Rekapitulace", rekap);
}
